// experiment with lex in vm
// incremental read without hard limit on input file size
// 28 Aug 2009

#include "compile.h"

#define MAXBUF      1000        // input buffer size
#define curChar     buf[TP]     // current char
#define lookahead   buf[TP+1]
#define eol         10
#define eof         -1
#define isSpace(c)  (int)spaceQ[((int)(c))&255]

extern FILE *FO, *FI;			// output/input file

//char spaceQ[256];
char spaceQ[] = {
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,0};

char buf[MAXBUF+5];	             // input limit
//  0:current, 1:next, 2:new[maxbuf], maxbuf+2:pad

//char CH;						// current char
int TP;                         // current token pointer
int line, col, tokcol;
char tokstring[100];			// current token
int cnt = 0;
/*
void initlex(void){
	int i;
	for(i=0; i<255; i++) spaceQ[i] = 1;
	for(i=33; i<127; i++) spaceQ[i] = 0;
	spaceQ[255] = 0;            // eof
    TP = 0;
    printf("spaceQ[] = {\n");
    for(i=0; i<255; i++){
        printf("%d,",spaceQ[i]);
        if( (i % 40) == 0) printf("\n");
    }
}
*/
void initlex(void){
     int k;
     k = fread(buf+2,1,MAXBUF,FI);
     cnt++;
     if( k < MAXBUF) buf[k+2] = eof;
     TP = 2;
//     CH = buf[TP];
     line = 0; col = 0;
}

// stop at EOF
// when buf[.] is exhausted
// the last two are moved to front
// read in a new buf, MAXBUF char
// the first two is a continuation from the previous read
char getC(void){
//	char c;
	int k;
	if (buf[TP] == eof) return eof;
	if (TP == (MAXBUF-1)){
        buf[0] = buf[MAXBUF];
        buf[1] = buf[MAXBUF+1];
        k = fread(buf+2,1,MAXBUF,FI);
        cnt++;
        if(k < MAXBUF) buf[k+2] = eof;
        TP = 0;
    }else
        TP++;
//	c = buf[TP];
//	printf("%c",c);
	col++;
	return curChar;
}
/*
int isSpace(char c){
    int d;
    d = ((int)c) & 255;
    return (int)spaceQ[d];
}

//char lookahead(void){return buf[TP+1];}

int isComment(char c){
    return (c == '/') && (lookahead == '/');
}
*/
/*  read the whole file at once
void readfile(FILE *fp, char *buf){
	int c;
	c = fread(buf,1,MAXBUF,fp);
	if (c != 0) buf[c] = eof;
	CH = buf[0];
	TP = 0;
	line = 0; col = 0;
}
*/
// return the last char
char skipblank(char c){
//	char c;
//	c = CH;
	while( 1 ) {
        if( isSpace(c) ){
            if( c == eol ){
                line++;
                col = 0;
            }
			c = getC();
        }else if((c == '/') && (lookahead == '/')){	// is comment
			do
				c = getC();
			while( c != eol );		// skip to eol
			line++;
			col = 0;
			c = getC();
		}else
			break;					// exit loop
	}
	return c;
}

void lex(void){
	char c, *tp;					// tokstring ptr
	c = skipblank(curChar);
	tokcol = col;
	tp = tokstring;
	while( (! isSpace(c)) && (c != eof) ){   // collect tokstring
		*tp = c;
		tp++;
		c = getC();
	}
	*tp = 0;					// terminate
//	CH = c;
}

void testlex(void){
     int i, oldline;
     FI = fopen("bubble.txt","r");
     initlex();
//     readfile(FI,buf);
     while(curChar != eof){
         oldline = line;
         lex();
         if( oldline != line ){
             printf("\n");
             for(i=1; i<tokcol; i++) printf(" ");
         }
         printf("%s ",tokstring);
     }
     fclose(FI);
     printf("\ncnt %d\n",cnt);
}
/*
void pascii(void){
	int i;
	for(i=32; i<127; i++){
		printf("%d:%c ",i,i);
		if( (i%10)==0 ) printf("\n");
	}
}
*/
